/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.138 by edhill, Sun Dec 4 13:57:08 2005 UTC revision 1.186 by jmc, Sun Mar 29 19:09:24 2009 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 282  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 321  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 535  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 545  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 675  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
750        echo $COMM >> genmake_warnings
751        $COMM >> genmake_warnings 2>&1
752      RET_C=$?      RET_C=$?
753      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
754        program hello        program hello
# Line 685  EOF Line 758  EOF
758        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
759        end        end
760  EOF  EOF
761      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
762        echo $COMM >> genmake_warnings
763        $COMM >> genmake_warnings 2>&1
764      RET_F=$?      RET_F=$?
765      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
766      RETVAL=$?      RETVAL=$?
# Line 698  EOF Line 773  EOF
773    
774    
775  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
776        if test ! "x$HAVE_SIGREG" = x ; then
777            return
778        fi
779      get_fortran_c_namemangling      get_fortran_c_namemangling
780      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
781  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 729  void FC_NAMEMANGLE(sigreg) (int * aip) Line 807  void FC_NAMEMANGLE(sigreg) (int * aip)
807      return;      return;
808  }  }
809  EOF  EOF
810      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
811        echo $COMM >> genmake_warnings
812        $COMM >> genmake_warnings 2>&1
813      RET_C=$?      RET_C=$?
814      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
815        program hello        program hello
# Line 755  EOF Line 835  EOF
835    
836    
837  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
838        if test "x$HAVE_SETRLSTK" = xt ; then
839            DEFINES="$DEFINES -DHAVE_SETRLSTK"
840            return
841        fi  
842        if test ! "x$HAVE_SETRLSTK" = x ; then
843            return
844        fi
845      get_fortran_c_namemangling      get_fortran_c_namemangling
846      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
847  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 770  void FC_NAMEMANGLE(setrlstk) () Line 857  void FC_NAMEMANGLE(setrlstk) ()
857      return;      return;
858  }  }
859  EOF  EOF
860      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
861        echo $COMM >> genmake_warnings
862        $COMM >> genmake_warnings 2>&1
863      RET_C=$?      RET_C=$?
864      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
865        program hello        program hello
# Line 814  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 903  void FC_NAMEMANGLE(tfsize) ( int *nbyte
903          *nbyte = -1;          *nbyte = -1;
904  }  }
905  EOF  EOF
906      make genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
907        echo $COMM >> genmake_warnings
908        $COMM >> genmake_tc.log 2>&1
909      RET_C=$?      RET_C=$?
910      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
911        program hello        program hello
# Line 865  EOF Line 956  EOF
956      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
957      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
958      RET_CPP=f      RET_CPP=f
959      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
960      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
961      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
962      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
963          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
964              >> genmake_tnc.log              >> genmake_tnc.log
# Line 875  EOF Line 966  EOF
966              >> genmake_tnc.log              >> genmake_tnc.log
967      fi      fi
968      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
969      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
970      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
971          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
972      RET_COMPILE=$?      RET_COMPILE=$?
973      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
974    
# Line 893  EOF Line 984  EOF
984      else      else
985          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
986          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
987          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
988          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
989          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
990          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
991              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
992              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
993          RET_COMPILE=$?          RET_COMPILE=$?
994          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
995          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
996              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
997              HAVE_NETCDF=t              HAVE_NETCDF=t
998            else
999            # try again with "-lnetcdff" added to the libs
1000                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1001                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1002                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1003                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1004                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
1005                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
1006                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1007                RET_COMPILE=$?
1008                cat genmake_tnc.log >> genmake_warnings
1009                if test "x$RET_COMPILE" = x0 ; then
1010                    LIBS="$LIBS -lnetcdff -lnetcdf"
1011                    HAVE_NETCDF=t
1012                fi
1013          fi          fi
1014      fi      fi
1015      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 939  OPTFILE= Line 1045  OPTFILE=
1045  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1046  FFLAGS=  FFLAGS=
1047  FOPTIM=  FOPTIM=
1048    FEXTRAFLAGS=
1049    USE_EXTENDED_SRC=
1050    EXTENDED_SRC_FLAG=
1051  CFLAGS=  CFLAGS=
1052  KFLAGS1=  KFLAGS1=
1053  KFLAGS2=  KFLAGS2=
# Line 950  NOOPTFLAGS= Line 1059  NOOPTFLAGS=
1059  MPI=  MPI=
1060  MPIPATH=  MPIPATH=
1061  TS=  TS=
1062    PAPIS=
1063    PCLS=
1064    FOOLAD=
1065    PAPI=
1066    PCL=
1067    HPMT=
1068    GSL=
1069    DEVEL=
1070  HAVE_TEST_L=  HAVE_TEST_L=
1071    
1072  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 957  HAVE_SYSTEM= Line 1074  HAVE_SYSTEM=
1074  HAVE_FDATE=  HAVE_FDATE=
1075  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1076  HAVE_CLOC=  HAVE_CLOC=
1077  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1078  HAVE_STAT=  HAVE_STAT=
1079  HAVE_NETCDF=  HAVE_NETCDF=
1080  HAVE_ETIME=  HAVE_ETIME=
# Line 974  BASH= Line 1091  BASH=
1091  PWD=`pwd`  PWD=`pwd`
1092  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1093  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1094    EMBED_SRC=
1095  THISHOST=`hostname`  THISHOST=`hostname`
1096  THISCWD=`pwd`  THISCWD=`pwd`
1097  THISDATE=`date`  THISDATE=`date`
# Line 1007  TAMC_EXTRA= Line 1125  TAMC_EXTRA=
1125    
1126  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1127  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1128  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1129    
1130  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1131  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1132  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1133  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1134  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 1037  EOF Line 1155  EOF
1155    
1156  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1157  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1158  printf "  getting local config information:  "  printf "  getting local config information:  "
1159  if test -f $gm_local ; then  if test -f $gm_local ; then
1160      echo "using $gm_local"      echo "using $gm_local"
# Line 1189  for ac_option in "$@" ; do Line 1301  for ac_option in "$@" ; do
1301    
1302          -ts | --ts)          -ts | --ts)
1303              TS=true ;;              TS=true ;;
1304            -papis | --papis)
1305                PAPIS=true ;;
1306            -pcls | --pcls)
1307                PCLS=true ;;
1308            -foolad | --foolad)
1309                FOOLAD=true ;;
1310            -papi | --papi)
1311                PAPI=true ;;
1312            -pcl | --pcl)
1313                PCL=true ;;
1314            -hpmt | --hpmt)
1315                HPMT=true ;;
1316    
1317            -gsl | --gsl)
1318                GSL=true ;;
1319    
1320            -devel | --devel)
1321                DEVEL=true ;;
1322    
1323          -mpi | --mpi)          -mpi | --mpi)
1324              MPI=true ;;              MPI=true ;;
# Line 1217  for ac_option in "$@" ; do Line 1347  for ac_option in "$@" ; do
1347          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1348              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1349    
1350            -es | --es | -embed-source | --embed-source)
1351                EMBED_SRC=t ;;
1352    
1353          -*)          -*)
1354              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1355              usage              usage
# Line 1235  done Line 1368  done
1368  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1369      echo      echo
1370      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1371      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1372      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1373      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1374      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1375      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1376      echo      echo
1377  fi  fi
1378    
1379  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1380  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1381      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1382      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1383          ROOTDIR=".."          ROOTDIR=".."
1384      else      else
1385          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1272  if test ! -d ${ROOTDIR} ; then Line 1404  if test ! -d ${ROOTDIR} ; then
1404  fi  fi
1405    
1406  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1407  if test -f "${ROOTDIR}/doc/tag-index" ; then  version_file="${ROOTDIR}/doc/tag-index"
1408      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`  if test -f $version_file ; then
1409        THISVER=`grep '^checkpoint' $version_file | head -1`
1410    #-  remove ./BUILD_INFO.h file if older than version_file
1411        if test -f ./BUILD_INFO.h -a ./BUILD_INFO.h -ot $version_file ; then
1412            echo "  remove ./BUILD_INFO.h (older than ${version_file})"
1413            rm -f ./BUILD_INFO.h
1414        fi
1415  fi  fi
1416    
1417  if test "x$MAKEFILE" = x ; then  if test "x$MAKEFILE" = x ; then
# Line 1432  fi Line 1570  fi
1570    
1571  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1572        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
1573        DEFINES="$DEFINES -DTIME_PER_TIMESTEP"        if test ! "x$FOOLAD" = x ; then
1574                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1575          else
1576                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1577          fi
1578          PACKAGES="$PACKAGES showflops"
1579    fi
1580    if test ! "x$PAPIS" = x ; then
1581          echo "  Turning on PAPI flop summary per timestep"
1582          echo "  Please make sure PAPIINC, PAPILIB are defined"
1583          if test ! "x$FOOLAD" = x ; then
1584                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1585          else
1586                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1587          fi
1588          INCLUDES="$INCLUDES $PAPIINC"
1589          LIBS="$LIBS $PAPILIB"
1590          PACKAGES="$PACKAGES showflops"
1591    fi
1592    if test ! "x$PCLS" = x ; then
1593          echo "  Turning on PCL counter summary per timestep"
1594          echo "  Please make sure PCLINC, PCLLIB are defined"
1595          if test ! "x$FOOLAD" = x ; then
1596                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1597          else
1598                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1599          fi
1600          INCLUDES="$INCLUDES $PCLINC"
1601          LIBS="$LIBS $PCLLIB"
1602          PACKAGES="$PACKAGES showflops"
1603    fi
1604    if test ! "x$PAPI" = x ; then
1605          if test ! "x$PAPIS" = x ; then
1606              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1607              echo "  Sticking with PAPI flop summary per timestep!"
1608          else
1609              echo "  Turning on performance analysis with PAPI"
1610              echo "  Please make sure PAPIINC, PAPILIB are defined"
1611              DEFINES="$DEFINES -DUSE_PAPI"
1612              INCLUDES="$INCLUDES $PAPIINC"
1613              LIBS="$LIBS $PAPILIB"
1614          fi
1615    fi
1616    if test ! "x$PCL" = x ; then
1617          if test ! "x$PCLS" = x ; then
1618              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1619              echo "  Sticking with PCL flop summary per timestep!"
1620          else
1621              echo "  Turning on performance analysis with PCL"
1622              echo "  Please make sure PCLINC, PCLLIB are defined"
1623              DEFINES="$DEFINES -DUSE_PCL"
1624              INCLUDES="$INCLUDES $PCLINC"
1625              LIBS="$LIBS $PCLLIB"
1626          fi
1627    fi
1628    if test ! "x$HPMT" = x ; then
1629          if test ! "x$PAPI" = x ; then
1630              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1631              echo "  Sticking with PAPI!"
1632          else if test ! "x$PCL" = x ; then
1633              echo "  PCL and the HPM Toolkit cannot co-exist!"
1634              echo "  Sticking with PCL!"
1635          else
1636              echo "  Turning on performance analysis with the HPM Toolkit"
1637              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1638              DEFINES="$DEFINES -DUSE_LIBHPM"
1639              INCLUDES="$INCLUDES $HPMTINC"
1640              LIBS="$LIBS $HPMTLIB"
1641          fi
1642          fi
1643    fi
1644    if test ! "x$GSL" = x ; then
1645          echo "  Turning on use of GSL to control floating point calculations"
1646          echo "  Please make sure GSLINC, GSLLIB are defined"
1647          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1648          INCLUDES="$INCLUDES $GSLINC"
1649          LIBS="$LIBS $GSLLIB"
1650    fi
1651    #- if USE_EXTENDED_SRC is set, add EXTENDED_SRC_FLAG to FFLAGS :
1652    if test ! "x$USE_EXTENDED_SRC" = x ; then
1653          FFLAGS="$FFLAGS $EXTENDED_SRC_FLAG"
1654          F90FIXEDFORMAT="$F90FIXEDFORMAT $EXTENDED_SRC_FLAG"
1655  fi  fi
1656    
1657  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 1503  if test "x$HAVE_CLOC" != x ; then Line 1722  if test "x$HAVE_CLOC" != x ; then
1722      echo "yes"      echo "yes"
1723  else  else
1724      echo "no"      echo "no"
1725        if test "x$EMBED_SRC" = xt ; then
1726            echo "    WARNING: you requested file embedding but it has"
1727            echo "      been disabled since C code cannot be called"
1728            EMBED_SRC=
1729        fi
1730  fi  fi
1731  rm -f genmake_t*  rm -f genmake_t*
1732    
1733  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1734  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1735  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1736      echo "yes"      echo "yes"
1737  else  else
1738      echo "no"      echo "no"
# Line 1517  rm -f genmake_t* Line 1741  rm -f genmake_t*
1741    
1742  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1743  check_HAVE_SIGREG  check_HAVE_SIGREG
1744  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1745      echo "yes"      echo "yes"
1746  else  else
1747      echo "no"      echo "no"
# Line 1542  else Line 1766  else
1766  fi  fi
1767  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1768    
1769    if test "x$EMBED_SRC" = xt ; then
1770        build_embed_encode
1771    fi
1772    if test "x$EMBED_SRC" = xt ; then
1773        ENABLE="$ENABLE embed_files"
1774    fi
1775    
1776    
1777  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1778  printf "  Adding MODS directories:  "  printf "  Adding MODS directories: "
1779    MPI_LNKF=
1780  for d in $MODS ; do  for d in $MODS ; do
1781      if test ! -d $d ; then      if test ! -d $d ; then
1782          echo          echo
1783          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1784          exit 1          exit 1
1785      else      else
1786          printf " $d"          printf "$d "
1787          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1788          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1789            #-------------------------------------------------------
1790            # Put special links so that MPI specific files are used
1791            MPI_FILES=`(cd $d ; find . -name "*_mpi" -print)`
1792            for i in $MPI_FILES ; do
1793              ii=`echo $i | sed 's:^\./::'`
1794              name=`echo $ii | sed 's:_mpi::' `
1795              if test "x$MPI" = x ; then
1796              # NO: We undo an _mpi symbolically linked file
1797                if test -L $name ; then
1798                  cmp $name "$d/$ii" > /dev/null 2>&1
1799                  RETVAL=$?
1800                  if test "x$RETVAL" = x0 ; then
1801                    printf "Un-linking $name ; "
1802                    rm -f $name
1803                  fi
1804                fi
1805              else
1806              # YES: We symbolically link this file (with conditions if already there)
1807                if test -L $name ; then
1808                  cmp $d/$ii $name > /dev/null 2>&1
1809                  RETVAL=$?
1810                  yy=0 ;
1811                  for xx in $MPI_LNKF ; do if test $xx = $name ; then yy=1 ; fi ; done
1812                  if test "x$RETVAL" != x0 -a $yy = 0 ; then
1813                  # remove sym-link if different and has not just been linked
1814                    printf "Un-link + "
1815                    rm -f $name
1816                  fi
1817                  if test "x$RETVAL" = x0 ; then
1818                  # if identical, keep sym-link and keep record of it
1819                    MPI_LNKF="$MPI_LNKF $name"
1820                  fi
1821                fi
1822                if ! test -f $name ; then
1823                  # make sym-link and keep record of it
1824                    printf "Linking $ii to $name ; "
1825                    ln -sf $d/$ii $name
1826                    MPI_LNKF="$MPI_LNKF $name"
1827                fi
1828              fi
1829            done
1830            #-------------------------------------------------------
1831      fi      fi
1832  done  done
1833  echo  echo
1834    #echo "MPI_LNKF='$MPI_LNKF'"
1835    
1836  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1837      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
# Line 1627  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1903  if test -r $ROOTDIR"/eesupp/src/Makefile
1903      fi      fi
1904  fi  fi
1905    
1906  #same for exch2  #same for pkg/exch2 and pkg/regrid
1907  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1908      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1909      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1910      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1911      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1912          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1913      else              rm -f make_${pdir}.errors
1914          echo "Error: problem encountered while building source files in exch2:"          else
1915          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1916          exit 1              cat make_${pdir}.errors 1>&2
1917                exit 1
1918            fi
1919      fi      fi
1920  fi  done
1921    
1922  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1923  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1750  done Line 2028  done
2028  rm -f ./.tmp_pack  rm -f ./.tmp_pack
2029  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
2030    
2031  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
2032  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
2033  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
2034  RETVAL=$?  RETVAL=$?
2035  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1785  EOF Line 2063  EOF
2063      fi      fi
2064  fi  fi
2065    
2066    #  Check for package PROFILES: if NetCDF is not available,
2067    #  then delete profiles from the list of available packages.
2068    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2069    RETVAL=$?
2070    if test "x$RETVAL" = x0 ; then
2071        if test "x$HAVE_NETCDF" != xt ; then
2072            cat <<EOF
2073    
2074    *********************************************************************
2075    WARNING: the "profiles" package was enabled but tests failed to
2076      compile NetCDF applications.  Please check that:
2077    
2078      1) NetCDF is correctly installed for this compiler and
2079      2) the LIBS variable (within the "optfile") specifies the correct
2080           NetCDF library to link against.
2081    
2082      Due to this failure, the "profiles" package is now DISABLED.
2083    *********************************************************************
2084    
2085    EOF
2086            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2087            DISABLE="$DISABLE profiles"
2088        fi
2089    fi
2090    
2091  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2092  ck=  ck=
2093  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2094      i=0      i=0
2095      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2096      rtot=$nname      rtot=$nname
2097      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2098    
2099          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2100          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1825  while test "x$ck" != xtt ; do Line 2128  while test "x$ck" != xtt ; do
2128    
2129          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2130          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2131                #echo "   " $pname ": need to add :" $dname
2132              in_dis="f"              in_dis="f"
2133              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2134                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1969  fi Line 2273  fi
2273    
2274  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
2275  #  compiler.  #  compiler.
2276  if test -f ./ad_files ; then  if test -f ./adSrcFiles.tmp ; then
2277      rm -f ./ad_files      rm -f ./adSrcFiles.tmp
2278  fi  fi
2279  echo "  Creating the list of files for the adjoint compiler."  echo "  Creating the list of files for the adjoint compiler."
2280  for i in $SOURCEDIRS ; do  for i in $SOURCEDIRS ; do
2281      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2282      for j in $list_files ; do      for j in $list_files ; do
2283          cat $i/$j >> ad_files          cat $i/$j >> adSrcFiles.tmp
2284      done      done
2285  done  done
2286  if test ! "x"$FS = "x.f" ; then  if test ! "x"$FS = "x.f" ; then
2287      cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f      cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2288      mv -f ad_files_f ad_files      mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2289  fi  fi
2290    
2291  echo  echo
# Line 1993  for i in $INCLUDEDIRS ; do Line 2297  for i in $INCLUDEDIRS ; do
2297      fi      fi
2298  done  done
2299    
2300    if test ! "x$DIVA" = x ; then
2301        echo "  Creating the pseudo-MPI include directory"
2302        INCLUDES="-I./mpi_headers $INCLUDES"
2303        rm -rf ./mpi_headers
2304        mkdir -p ./mpi_headers
2305    
2306        if test "x$MPIINCLUDEDIR" = x ; then
2307            if test "x$MPIHOME" = x ; then
2308                MPIHOME='/usr'
2309            fi
2310            MPIINCLUDEDIR='$MPIHOME/include'
2311        fi
2312        
2313        if test -r $MPIINCLUDEDIR/mpif.h ; then
2314            for i in $MPI_HEADER_FILES; do
2315                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2316            done
2317    
2318            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2319        else
2320            echo " We cannot create a copy of mpif.h!"
2321    #       exit -1
2322        fi
2323    fi
2324    
2325  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2326  rm -rf .links.tmp  rm -rf .links.tmp
2327  mkdir .links.tmp  mkdir .links.tmp
2328    touch .links.tmp/foo
2329    if test ! -r ".links.tmp/foo" ; then
2330        echo
2331        echo "ERROR : something is wrong with your directory permissions or"
2332        echo "   your user file-creation mask (\"umask\") since creating a"
2333        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2334        echo "   not working.  Please try setting your umask to something"
2335        echo "   sane such as:"
2336        echo
2337        echo "      umask 0002"
2338        echo
2339        echo "   and please verify that you have the proper permissions for"
2340        echo "   creating sub-directories and then reading files created"
2341        echo "   within them."
2342        echo
2343        exit 1
2344    fi
2345    rm -f .links.tmp/foo
2346    
2347    if test "x$OPENAD" != x ; then
2348        OAD_DONT_COMPILE="/dev/null"
2349        OAD_DONT_TRANSFORM="/dev/null"
2350        OAD_KEEP_ORIGINAL="/dev/null"
2351        OAD_CB2M_FILES="/dev/null"
2352        echo "  looking for dontCompile file:  "
2353        for i in "." $MODS ; do
2354            if test -r $i"/dontCompile" ; then
2355                OAD_DONT_COMPILE=$i"/dontCompile"
2356                echo "     found $OAD_DONT_COMPILE"
2357                break
2358            fi
2359        done
2360        echo "  looking for dontTransform file:  "
2361        for i in "." $MODS ; do
2362            if test -r $i"/dontTransform" ; then
2363                OAD_DONT_TRANSFORM=$i"/dontTransform"
2364                echo "     found $OAD_DONT_TRANSFORM"
2365                break
2366            fi
2367        done
2368        echo "  looking for keepOriginal file:  "
2369        for i in "." $MODS ; do
2370            if test -r $i"/keepOriginal" ; then
2371                OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2372                echo "     found $OAD_KEEP_ORIGINAL"
2373                break
2374            fi
2375        done
2376        echo "  looking for cb2mFiles:  "
2377        for i in "." $MODS ; do
2378            if test -r $i"/cb2mFiles" ; then
2379                OAD_CB2M_FILES=$i"/cb2mFiles"
2380                echo "     found $OAD_CB2M_FILES"
2381                break
2382            fi
2383        done
2384        echo "   OpenAD exceptions:  "
2385    fi
2386    
2387  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2388  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2389  printf 'SRCFILES = '    > srclist.inc  printf 'F77_SRC_FILES = ' > F77srclist.tmp
2390  printf 'CSRCFILES = '   > csrclist.inc  printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2391  printf 'F90SRCFILES = ' > f90srclist.inc  printf 'C_SRC_FILES = '   > csrclist.tmp
2392  printf 'HEADERFILES = ' > hlist.inc  printf 'F90_SRC_FILES = ' > F90srclist.tmp
2393  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'H_SRC_FILES = '   > hsrclist.tmp
2394    printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2395  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2396  for d in $alldirs ; do  for d in $alldirs ; do
2397      deplist=      deplist=
2398      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2399      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2400        if test "x$OPENAD" != x ; then
2401            sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2402        fi
2403      for sf in $sfiles ; do      for sf in $sfiles ; do
2404          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2405              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2406                  ignore_f=f                  ignore_f=f
2407                  case $d/$sf in                  case $d/$sf in
2408                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2409                            ignore_f=t
2410                          ;;                          ;;
2411                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2412                            ignore_f=t
2413                          ;;                          ;;
2414                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2415                            ignore_f=t
2416                          ;;                          ;;
2417                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2418                            ignore_f=t
2419                            ;;
2420                      ./EMBEDDED_FILES.h)
2421                            ignore_f=t
2422                          ;;                          ;;
2423                    *)                    *)
2424                          #  For the local directory *ONLY*,                          #  For the local directory *ONLY*,
# Line 2035  for d in $alldirs ; do Line 2434  for d in $alldirs ; do
2434                  if test "x$ignore_f" = xf ; then                  if test "x$ignore_f" = xf ; then
2435                      extn=`echo $sf | $AWK -F. '{print $NF}'`                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2436                      case $extn in                      case $extn in
2437                          F)                        F)
2438                              echo    " \\"  >> srclist.inc                          echo    " \\"  >> F77srclist.tmp
2439                              printf " $sf" >> srclist.inc                          printf " $sf" >> F77srclist.tmp
2440                              ;;                          if test "x$OPENAD" != x ; then
2441                          F90)                              basename=${sf%%.F}
2442                              echo    " \\"  >> f90srclist.inc                              isAD=`egrep ^$basename.f'[  ]*' adSrcFiles.tmp`
2443                              printf " $sf" >> f90srclist.inc                              if test -z "$isAD" ; then
2444                              ;;                                  toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE}`
2445                          c)                                  if test -z "$toBeIgnored" ; then
2446                              echo    " \\"  >> csrclist.inc                                      echo    " \\"  >> nonADF77srclist.tmp
2447                              printf " $sf" >> csrclist.inc                                      printf " $sf" >> nonADF77srclist.tmp
2448                              ;;                                  else
2449                          h)                                      echo "    not to be compiled   :  $sf"
2450                              echo    " \\"  >> hlist.inc                                  fi
2451                              printf " $sf" >> hlist.inc                              else # file is initially listed as an AD file we want to exclude it
2452                              ;;                                   # or we want to retain the untransformed version
2453                          flow)                                  notToBeTransformed=`egrep ^$basename'[      ]*' ${OAD_DONT_TRANSFORM}`
2454                              echo    " \\"  >> ad_flow_files.inc                                  untransformedVersionToBeKept=`egrep ^$basename'[      ]*' ${OAD_KEEP_ORIGINAL}`
2455                              printf " $sf" >> ad_flow_files.inc                                  if test -n "$notToBeTransformed"; then
2456                              ;;                                      echo "    not to be transformed:  $sf"
2457                      esac                                  fi
2458                  fi                                  if test -n "$untransformedVersionToBeKept" ; then
2459                                        echo "    original to be kept  :  $sf"
2460                                    fi    
2461                                    if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2462                                        echo    " \\"  >> nonADF77srclist.tmp
2463                                        printf " $sf" >> nonADF77srclist.tmp
2464                                    fi
2465                                fi
2466                            fi
2467                            ;;
2468                        F90)
2469                            echo    " \\"  >> F90srclist.tmp
2470                            printf " $sf" >> F90srclist.tmp
2471                            ;;
2472                        c)
2473                            echo    " \\"  >> csrclist.tmp
2474                            printf " $sf" >> csrclist.tmp
2475                            ;;
2476                        h)
2477                            echo    " \\"  >> hsrclist.tmp
2478                            printf " $sf" >> hsrclist.tmp
2479                            ;;
2480                        flow)
2481                            echo    " \\"  >> ad_flow_files.tmp
2482                            printf " $sf" >> ad_flow_files.tmp
2483                            ;;
2484                       esac
2485                    fi
2486              fi              fi
2487          fi          fi
2488      done      done
2489      if test "x$deplist" != x ; then      if test "x$deplist" != x ; then
2490          echo "" >> srclinks.tmp        if test "$d" != "." ; then
2491            echo "" >> srclinks.tmp
2492          echo "#  These files are linked from $d" >> srclinks.tmp          echo "#  These files are linked from $d" >> srclinks.tmp
2493          echo "$deplist :" >> srclinks.tmp          echo "$deplist :" >> srclinks.tmp
2494          printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp  # We need to make sure that the link isn't already there.
2495    # This may happen when make thinks that a header file has to be "remade"
2496    # because a module it depends on has changed.  In this case we do nothing.
2497            printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2498          fi
2499      fi      fi
2500  done  done
2501  rm -rf .links.tmp  rm -rf .links.tmp
2502  echo "" >> srclist.inc  echo "" >> F77srclist.tmp
2503  echo "" >> csrclist.inc  echo "" >> nonADF77srclist.tmp
2504  echo "" >> f90srclist.inc  echo "" >> csrclist.tmp
2505  echo "" >> hlist.inc  echo "" >> F90srclist.tmp
2506  echo "" >> ad_flow_files.inc  echo "" >> hsrclist.tmp
2507    echo "" >> ad_flow_files.tmp
2508    
2509  if test -f $MAKEFILE ; then  if test -f $MAKEFILE ; then
2510      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 2132  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2564  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2564    
2565  # These files are created by Makefile  # These files are created by Makefile
2566  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2567  EOF  EOF
2568    
2569  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2570        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2571    else
2572        echo "EMBEDDED_FILES = " >>$MAKEFILE
2573    fi
2574    
2575    #  Note: figure out some way to add Hyades JAM libraries here
2576  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2577  # Unix ln (link)  # Unix ln (link)
2578  LN = ${LN}  LN = ${LN}
# Line 2163  INCLUDES = ${INCLUDES} Line 2599  INCLUDES = ${INCLUDES}
2599  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2600  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2601  # Optim./debug for FC  # Optim./debug for FC
2602  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2603  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2604  # Optim./debug for FC  # Optim./debug for FC
2605  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
2606  F90OPTIM = ${F90OPTIM}  F90OPTIM = ${F90OPTIM}
2607    F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2608  # Flags for CC  # Flags for CC
2609  CFLAGS = ${CFLAGS}  CFLAGS = ${CFLAGS}
2610  # Files that should not be optimized  # Files that should not be optimized
# Line 2180  MAKEFILE=${MAKEFILE} Line 2617  MAKEFILE=${MAKEFILE}
2617    
2618  EOF  EOF
2619    
2620  cat srclist.inc       >> $MAKEFILE  cat F77srclist.tmp      >> $MAKEFILE
2621  cat csrclist.inc      >> $MAKEFILE  cat nonADF77srclist.tmp >> $MAKEFILE
2622  cat f90srclist.inc    >> $MAKEFILE  cat csrclist.tmp        >> $MAKEFILE
2623  cat hlist.inc         >> $MAKEFILE  cat F90srclist.tmp      >> $MAKEFILE
2624  cat ad_flow_files.inc >> $MAKEFILE  cat hsrclist.tmp        >> $MAKEFILE
2625    cat ad_flow_files.tmp   >> $MAKEFILE
2626    
2627    rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2628    
2629  echo >> $MAKEFILE  echo >> $MAKEFILE
2630  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  
2631  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE  # add definitions for preprocessed sources
2632  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  # and note that not all systems allow case sensitive extensions
2633    # hence the $FS and $FS90 here.
2634    # for fixed format f90 files we use ff90 or FF90 resp
2635    # but these are not expected to be the original source files
2636    
2637    echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')'      >> $MAKEFILE
2638    echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2639    echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2640    echo 'FLOFILES =  $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2641  echo >> $MAKEFILE  echo >> $MAKEFILE
2642  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
2643  echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE  echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  
 rm -f ad_flow_files.inc  
2644    
2645  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2646    
2647  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2648  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2649          @echo Creating \$@ ...          @echo Creating \$@ ...
2650          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2651  depend:  depend:
2652          @make links          @make links
2653          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2654          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2655          -rm -f makedepend.out          -rm -f makedepend.out
2656    
# Line 2211  lib: libmitgcmuv.a Line 2658  lib: libmitgcmuv.a
2658    
2659  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2660          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2661            ar d   libmitgcmuv.a main.o
2662    
2663  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2664    
2665  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2666    
2667  output.txt: \$(EXECUTABLE)  output.txt: \$(EXECUTABLE)
2668          @printf 'running ... '          @printf 'running ... '
2669          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2670    
2671  clean:  clean:
2672          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2673            -rm -rf *.o
2674            -rm -rf *.$FS *.flowdir
2675            -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2676            -rm -rf temp.sed
2677  Clean:  Clean:
2678          @make clean          @make clean
2679          @make cleanlinks          @make cleanlinks
2680          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2681          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2682            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2683  CLEAN:  CLEAN:
2684          @make Clean          @make Clean
2685          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2686          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2687          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2688          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2689            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2690            -rm -rf mnc_test_*
2691    
2692  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2693  makefile:  makefile:
# Line 2240  makefile: Line 2695  makefile:
2695  cleanlinks:  cleanlinks:
2696          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2697    
2698  # Special targets (SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are created by make
2699  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2700          @echo Creating \$@ ...          @echo Creating \$@ ...
2701          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 2260  test ! "x$THISUSER" = x && echo "      -echo Line 2715  test ! "x$THISUSER" = x && echo "      -echo
2715  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2716  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2717    
2718    if test "x$EMBED_SRC" = xt ; then
2719        cat >>$MAKEFILE <<EOF
2720    
2721    decode_files.o : EMBEDDED_FILES.h
2722    
2723    ##  \$(F77_PP_SRC_FILES)
2724    all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2725            @echo Creating \$@ ...
2726            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2727            -rm -f all_fF.tar.gz
2728            -gzip all_fF.tar
2729    
2730    EMBEDDED_FILES.h : all_fF.tar.gz
2731            @echo Creating \$@ ...
2732            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2733    
2734    EOF
2735    fi
2736    
2737  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2738    
2739  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2273  cat >>$MAKEFILE <<EOF Line 2747  cat >>$MAKEFILE <<EOF
2747          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2748  .F90.$FS90:  .F90.$FS90:
2749          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2750    .FF90.f$FS90:
2751            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2752  .$FS90.o:  .$FS90.o:
2753          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2754    .f$FS90.o:
2755            cp \$< \$(basename  \$<).f90
2756            \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename  \$<).f90
2757  .c.o:  .c.o:
2758          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2759    .flow.flowdir:
2760            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2761    
2762  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2763  .F.p:  .F.p:
# Line 2284  cat >>$MAKEFILE <<EOF Line 2765  cat >>$MAKEFILE <<EOF
2765  .p.$FS:  .p.$FS:
2766          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2767    
2768    EOF
2769    
2770  #=========================================  #=========================================
2771  #===  Automatic Differentiation Rules  ===  #===  Automatic Differentiation Rules  ===
2772    #===  for TAMC/TAF  ======================
2773    
2774    if test "x$OPENAD" = x ; then
2775    
2776    cat >>$MAKEFILE <<EOF
2777    
2778  TAMC           = ${TAMC}  TAMC           = ${TAMC}
2779  TAF            = ${TAF}  TAF            = ${TAF}
# Line 2300  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2788  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2788  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2789  for i in $ad_vars ; do  for i in $ad_vars ; do
2790      name=$i      name=$i
2791      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2792      eval $t1      eval $t1
2793      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2794      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2795  done  done
2796    
2797  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2798  echo >> $MAKEFILE  echo >> $MAKEFILE
2799  printf "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2800  AD_FILES=`cat ad_files`  AD_FILES=`cat adSrcFiles.tmp`
2801  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2802      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2803      printf " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2804  done  done
2805  echo >> $MAKEFILE  echo >> $MAKEFILE
2806  rm -f ad_files  rm -f adSrcFiles.tmp
2807    
2808  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2809    
2810  # ... AD ...  # ... AD ...
2811  adall: ad_taf  adall: \$(EXE_AD)
2812  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2813  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2814    
2815  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2816          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2817          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2818          -rm -f ad_config.template          -rm -f ad_config.template
2819          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2820          @make \$(AD_FLOW_FILES)          @make \$(FLOFILES)
2821          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS          cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2822    
2823  ad_taf_output.$FS: ad_input_code.$FS  ad_taf_output.$FS: ad_input_code.$FS
2824          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2825            ls -l ad_input_code_ad.$FS
2826          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2827    
2828  adtafonly:  adtafonly:
2829          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2830            ls -l ad_input_code_ad.$FS
2831          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2832    
2833  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2834          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2835    
2836  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2837          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
# Line 2361  ftlall: ftl_taf Line 2851  ftlall: ftl_taf
2851  ftltaf: ftl_taf_output.$FS  ftltaf: ftl_taf_output.$FS
2852  ftltamc: ftl_tamc_output.$FS  ftltamc: ftl_tamc_output.$FS
2853    
2854  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2855          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2856          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2857          -rm -f ftl_config.template          -rm -f ftl_config.template
2858          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2859          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2860          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2861    
2862  ftl_taf_output.$FS: ftl_input_code.$FS  ftl_taf_output.$FS: ftl_input_code.$FS
2863          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2864            ls -l ftl_input_code_ftl.$FS
2865          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2866    
2867  ftltafonly:  ftltafonly:
2868          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2869            ls -l ftl_input_code_ftl.$FS
2870          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2871    
2872  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
# Line 2412  svd_touch: Line 2904  svd_touch:
2904          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2905          -rm -f ftl_config.template          -rm -f ftl_config.template
2906    
2907  #=========================================  EOF
2908    
2909    fi
2910    
2911    #===  for OpenAD  ========================
2912    
2913    if test "x$OPENAD" != x ; then
2914    
2915    # ============ begin OpenAD specific section ==============
2916    
2917    cat >>$MAKEFILE <<EOF
2918    
2919    # all the source files linked from the various locations:
2920    ALL_LINKED_FILES= \
2921    \$(F77_SRC_FILES) \
2922    \$(C_SRC_FILES) \
2923    \$(H_SRC_FILES) \
2924    \$(F90_SRC_FILES) \
2925    \$(SPECIAL_FILES)
2926    
2927    ifndef OPENADROOT
2928      \$(error "Error:  environment variable OPENADROOT not defined!")
2929    endif
2930    
2931    ifndef XAIFSCHEMAROOT
2932      \$(error "Error:  environment variable XAIFSCHEMAROOT not defined!")
2933    endif
2934    
2935    ifndef XAIFBOOSTERROOT
2936      \$(error "Error:  environment variable XAIFBOOSTERROOT not defined!")
2937    endif
2938    
2939    EOF
2940    
2941    echo "  Add the source list for common block to module conversion "
2942    echo >> $MAKEFILE
2943    printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2944    for i in `cat ${OAD_CB2M_FILES}` ; do
2945      echo    " \\" >> $MAKEFILE
2946      printf " $i" >> $MAKEFILE
2947    done
2948    echo >> $MAKEFILE
2949    
2950    echo "  Add the source list for AD code generation"
2951    echo >> $MAKEFILE
2952    printf "AD_FILES = " >> $MAKEFILE
2953    for i in `cat ${OAD_CB2M_FILES}` ; do
2954      echo    " \\" >> $MAKEFILE
2955      printf " ${i}_mod.f$FS90" >> $MAKEFILE
2956    done
2957    AD_FILES=`cat adSrcFiles.tmp`
2958    for i in $AD_FILES ; do
2959      basename=${i%%.f}
2960      toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2961      if test -z "$toBeIgnored" ; then
2962        echo    " \\" >> $MAKEFILE
2963        printf " $i" >> $MAKEFILE
2964      fi
2965    done
2966    echo >> $MAKEFILE
2967    rm -f adSrcFiles.tmp
2968    
2969    cat >>$MAKEFILE <<EOF
2970    
2971    adAll: \$(EXE_AD)
2972    .PHONY: adAll
2973    
2974    CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2975    
2976    .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2977    
2978    .PHONY: adDepend
2979    adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2980            \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2981            \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2982            -rm -f makedepend.out
2983    
2984    OPENAD_SUPPORT_F90_SRC_FILES = \
2985    w2f__types.F90 \
2986    OAD_active.F90 \
2987    OAD_cp.F90 \
2988    OAD_rev.F90 \
2989    OAD_tape.F90        
2990    
2991    OPENAD_SUPPORT_C_SRC_FILES = \
2992    iaddr.c \
2993    timeRatio.c
2994    
2995    f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2996            cat \$^ > \$@
2997    
2998    f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2999            cat \$^ > \$@
3000    
3001    f95_test.out: f95_test_mods.f90 f95_test.f90
3002            f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
3003            f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
3004    
3005    AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o  ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
3006    
3007    \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
3008            @echo Creating \$@ ...
3009            \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
3010    
3011    # makefile debug rule
3012    openad: ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3013    .PHONY: openad
3014    
3015    # create the module files
3016    %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
3017            ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
3018    
3019    # create the header files
3020    %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
3021            ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
3022    
3023    # change everybody else to use the new module files:
3024    %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
3025            ../OAD_support/cb2mUseModules.bash $< ${MPI}
3026    
3027    # makefile debug rule
3028    small_f: \$(CB2M_F90_PP_SRC_FILES)
3029    .PHONY: small_f
3030    
3031    ad_output.txt: \$(EXE_AD)
3032            @printf 'linking data files ... '
3033            \$(LN) -f ../input_ad/data* ../input_ad/eedata .
3034            \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
3035            @printf 'running ... '
3036            @./\$(EXE_AD) > \$@
3037    
3038    CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
3039    ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
3040            cat \$^ > \$@
3041    
3042    # strip all comments and blanks to reduce
3043    # the file size in order to reduce perl's memory requirements
3044    ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
3045            cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
3046    
3047    # mfef90 preprocessing
3048    # expand statement functions
3049    # expose mfef90 specific substring handling
3050    # add the w2f__types module
3051    ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
3052            ./mfef90 -r8 -z -F -N132 \$<
3053            mv \$<.B \$(basename \$<).B
3054            ./whirl2f -openad \$(basename \$<).B
3055            cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
3056    
3057    # canonicalizer
3058    ad_input_code_sf.w2f.pre.f$FS90: ad_input_code_sf.w2f.f$FS90 preProcess.py
3059            ./preProcess.py -H -S \$< -o \$@
3060    
3061    # F -> WHIRL
3062    # note that the canonicalized version cuts off at col 72
3063    # doing this also for string constants which is ok as long
3064    # as we are in fixed mode and cut of exactly there.
3065    # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3066    # characters respectively.
3067    ad_input_code_sf.w2f.pre.B: ad_input_code_sf.w2f.pre.f$FS90 mfef90
3068            ./mfef90 -r8 -z -F \$<
3069            mv \$<.B \$@
3070    
3071    # WHIRL -> XAIF
3072    ad_input_code_sf.w2f.pre.xaif : ad_input_code_sf.w2f.pre.B whirl2xaif
3073            ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3074    
3075    # XAIF -> XAIF'
3076    ad_input_code_sf.w2f.pre.xb.xaif : ad_input_code_sf.w2f.pre.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd oadDriver
3077            ./oadDriver -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3078    
3079    # XAIF' -> WHIRL'
3080    ad_input_code_sf.w2f.pre.xb.x2w.B : ad_input_code_sf.w2f.pre.xb.xaif xaif2whirl
3081            ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.pre.B \$<
3082    
3083    # WHIRL' -> F'
3084    ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.B whirl2f whirl2f_be
3085            ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3086    
3087    # insert template directives
3088    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90 ../OAD_support/insertTemplateDir.bash
3089            ../OAD_support/insertTemplateDir.bash \$< \$@
3090    
3091    PPEXTRAS=\$(wildcard ../OAD_support/ad_template.*.F) ../OAD_support/ad_inline.F
3092    # postprocess F'
3093    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90 multi-pp.pl \$(PPEXTRAS:.F=.f)
3094            perl multi-pp.pl -inline=../OAD_support/ad_inline.f \$<
3095            # the postprocessor still gets the name wrong
3096            cat \$<.pp | sed 's/RETURN//' > \$@
3097    
3098    # extract all transformed modules
3099    all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3100            cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3101    
3102    # remove the transformed globals module from the
3103    # transformed ad_input_code file
3104    # and remove for now the duplicate variables
3105    # and fix 2 data statements
3106    ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3107            cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^      INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3108    
3109    # setup some links
3110    %.xsd:
3111            \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3112    
3113    mfef90:
3114            \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3115    
3116    # link the support files:
3117    \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3118            \$(LN) ../OAD_support/\$@ .
3119    
3120    whirl2xaif xaif2whirl:
3121            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3122    
3123    %.pl:
3124            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3125    
3126    preProcess.py:
3127            \$(LN) \${OPENADFORTTK_BASE}/tools/SourceProcessing/\$@ .
3128    
3129    whirl2f whirl2f_be:
3130            \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3131    
3132    oadDriver:
3133            \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/driver/oadDriver \$@
3134    
3135    # ============ end OpenAD specific section ==============
3136    
3137  EOF  EOF
3138    
3139    fi
3140    
3141    #=========================================
3142    
3143  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
3144      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3145  fi  fi

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.186

  ViewVC Help
Powered by ViewVC 1.1.22